# Dojo

[Compass Labs](https://compasslabs.ai/) 🧭 developed Dojo, an agent-based DeFi simulation software for data sourcing, strategy development, backtesting, simulation, monitoring and execution. Dojo operates at the EVM smart contract level for realistic and risk-free testing and training of DeFi strategies and smart contracts.

---

## What Can You Do With Dojo?

- **Data Access**: Trusted data sourcing across all of DeFi.
- **Strategy Development**: Abstract, easy-to-use interface for interacting with different DeFi protocols.
- **Risk Management**: Backtest and simulate your trading strategies pre-deployment. Monitor how your strategy would have performed in the past.
- **Analytics Dashboard**: Visualize your results on our dashboard.

## What's Coming Next

- Switch from backtesting to live-execution. Check on/interact with your runner in real-time using a Telegram bot.
- Integration with more DeFi protocols.
- Support for more networks and Layer-2s.

## What Makes Dojo Unique?

- Dojo executes the exact same code as the Ethereum Virtual Machine (EVM) and is therefore able to simulate the behavior of smart contracts with accuracy.
- With Dojo, we abstract away solidity and allow you to interact with smart contracts using simple Python interfaces.
- We provide all historic data, you won't have to care about it at all.
- Dojo has a [dashboard](https://compasslabs.ai/docs/download-dashboard) to visualize your simulations.

## How To Get Started

We recommend working through our [tutorials](http://compasslabs.ai/docs/examples) on Uniswap, Aave and GMX to get started. 
If you have any feature request or bug report, please open an issue on [GitHub](https://github.com/CompassLabs/dojo_examples).  
We are also happy to answer any questions you may have via [mail](mailto:contact@compasslabs.ai).

---

**Some Impressions**

![](https://drive.google.com/uc?export=download&id=1zKLtSiLPV4ys9YG_4i_xRYIBCViP_y38)

![](https://drive.google.com/uc?export=download&id=1bnfaHIKgy-vtbWRwg0m0zpr1BCAwGghJ)

![](https://drive.google.com/uc?export=download&id=1fl5IFfj2UflDy-bPAgaR1GBZ3SD36obU)

![](https://drive.google.com/uc?export=download&id=1KKMu12GdDjI6Ww7kSC-wAoDztiYossSG)