"""Arbitrum token config for gmxv2."""


ARBITRUM_TOKENS = {
    "tokens": [
        {
            "symbol": "APE",
            "address": "0x74885b4D524d497261259B38900f54e6dbAd2210",
            "decimals": 18,
        },
        {
            "symbol": "ETH",
            "address": "0x82aF49447D8a07e3bd95BD0d56f35241523fBab1",
            "decimals": 18,
        },
        {
            "symbol": "BTC",
            "address": "0x47904963fc8b2340414262125aF798B9655E58Cd",
            "decimals": 8,
            "synthetic": True,
        },
        {
            "symbol": "tBTC",
            "address": "0x6c84a8f1c29108F47a79964b5Fe888D4f4D0dE40",
            "decimals": 18,
        },
        {
            "symbol": "WBTC.b",
            "address": "0x2f2a2543B76A4166549F7aaB2e75Bef0aefC5B0f",
            "decimals": 8,
        },
        {
            "symbol": "DOGE",
            "address": "0xC4da4c24fd591125c3F47b340b6f4f76111883d8",
            "decimals": 8,
            "synthetic": True,
        },
        {
            "symbol": "EIGEN",
            "address": "0x606C3e5075e5555e79Aa15F1E9FACB776F96C248",
            "decimals": 18,
        },
        {
            "symbol": "LTC",
            "address": "0xB46A094Bc4B0adBD801E14b9DB95e05E28962764",
            "decimals": 8,
            "synthetic": True,
        },
        {
            "symbol": "SHIB",
            "address": "0x3E57D02f9d196873e55727382974b02EdebE6bfd",
            "decimals": 18,
            "synthetic": True,
        },
        {
            "symbol": "SOL",
            "address": "0x2bcC6D6CdBbDC0a4071e48bb3B969b06B3330c07",
            "decimals": 9,
        },
        {
            "symbol": "STX",
            "address": "0xBaf07cF91D413C0aCB2b7444B9Bf13b4e03c9D71",
            "decimals": 6,
            "synthetic": True,
        },
        {
            "symbol": "UNI",
            "address": "0xFa7F8980b0f1E64A2062791cc3b0871572f1F7f0",
            "decimals": 18,
        },
        {
            "symbol": "LINK",
            "address": "0xf97f4df75117a78c1A5a0DBb814Af92458539FB4",
            "decimals": 18,
        },
        {
            "symbol": "ARB",
            "address": "0x912CE59144191C1204E64559FE8253a0e49E6548",
            "decimals": 18,
        },
        {
            "symbol": "XRP",
            "address": "0xc14e065b0067dE91534e032868f5Ac6ecf2c6868",
            "decimals": 6,
            "synthetic": True,
        },
        {
            "symbol": "USDC",
            "address": "0xaf88d065e77c8cC2239327C5EDb3A432268e5831",
            "decimals": 6,
        },
        {
            "symbol": "USDC.e",
            "address": "0xFF970A61A04b1cA14834A43f5dE4533eBDDB5CC8",
            "decimals": 6,
        },
        {
            "symbol": "USDT",
            "address": "0xFd086bC7CD5C481DCC9C85ebE478A1C0b69FCbb9",
            "decimals": 6,
        },
        {
            "symbol": "DAI",
            "address": "0xDA10009cBd5D07dd0CeCc66161FC93D7c9000da1",
            "decimals": 18,
        },
        {
            "symbol": "BNB",
            "address": "0xa9004A5421372E1D83fB1f85b0fc986c912f91f3",
            "decimals": 18,
        },
        {
            "symbol": "ATOM",
            "address": "0x7D7F1765aCbaF847b9A1f7137FE8Ed4931FbfEbA",
            "decimals": 6,
            "synthetic": True,
        },
        {
            "symbol": "NEAR",
            "address": "0x1FF7F3EFBb9481Cbd7db4F932cBCD4467144237C",
            "decimals": 24,
            "synthetic": True,
        },
        {
            "symbol": "AAVE",
            "address": "0xba5DdD1f9d7F570dc94a51479a000E3BCE967196",
            "decimals": 18,
        },
        {
            "symbol": "AVAX",
            "address": "0x565609fAF65B92F7be02468acF86f8979423e514",
            "decimals": 18,
        },
        {
            "symbol": "OP",
            "address": "0xaC800FD6159c2a2CB8fC31EF74621eB430287a5A",
            "decimals": 18,
        },
        {
            "symbol": "ORDI",
            "address": "0x1E15d08f3CA46853B692EE28AE9C7a0b88a9c994",
            "decimals": 18,
            "synthetic": True,
        },
        {
            "symbol": "GMX",
            "address": "0xfc5A1A6EB076a2C7aD06eD22C90d7E710E35ad0a",
            "decimals": 18,
        },
        {
            "symbol": "WIF",
            "address": "0xA1b91fe9FD52141Ff8cac388Ce3F10BFDc1dE79d",
            "decimals": 6,
        },
        {
            "symbol": "PEPE",
            "address": "0x25d887Ce7a35172C62FeBFD67a1856F20FaEbB00",
            "decimals": 18,
        },
        {
            "symbol": "wstETH",
            "address": "0x5979D7b546E38E414F7E9822514be443A4800529",
            "decimals": 18,
        },
        {
            "symbol": "USDe",
            "address": "0x5d3a1Ff2b6BAb83b63cd9AD0787074081a52ef34",
            "decimals": 18,
        },
        {
            "symbol": "SATS",
            "address": "0x2cD2eB61D17b78239Fcd19aafF72981B5D5eF319",
            "decimals": 6,
            "synthetic": True,
        },
        {
            "symbol": "POL",
            "address": "0x9c74772b713a1B032aEB173E28683D937E51921c",
            "decimals": 18,
            "synthetic": True,
        },
    ]
}
