from dataclasses import dataclass
from dojo.common.constants import Chain as Chain
from dojo.config import cfg as cfg
from typing import Any

def add(value: str, chain: Chain, protocol: str, contract: str | None = None) -> None: ...
def get_address(chain: Chain, protocol: str, contract: str) -> str: ...
def get_abi(chain: Chain, protocol: str, contract: str) -> str: ...
def list_protocol_contracts(chain: Chain, protocol: str) -> list[str]: ...
def get_token_sources(chain: Chain, token: str) -> list[str]: ...
def get_erc20_tokens_per_chain(chain: Chain) -> list[str]: ...

@dataclass
class Token:
    address: str
    start_block: int
    abi: str
    decimals: int
    sources: list[str]
    def __init__(self, address, start_block, abi, decimals, sources) -> None: ...

def get_token_by_name(chain: Chain, name: str) -> Token: ...
def get_token_names(chain: Chain, protocol: str, pool_address: str) -> list[str]: ...
def get_all_tokens(chain: Chain) -> dict[str, Any]: ...
def get_decimals(chain: Chain, token: str) -> int: ...
def get_all_gmx_markets(chain: Chain) -> list[tuple[str, str, str, str]]: ...
def get_market_token(*, chain: Chain, index_token: str, long_token: str, short_token: str) -> str: ...
